unit SchutzUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, ComCtrls, StdCtrls, Registry;

Procedure MakeScreenShot(Quelle: Hwnd; Ziel: TCanvas; X, Y: integer);
procedure hidebar(b:boolean);
function RegisterServiceProcess(dwProcessID, dwType: Integer): Integer; stdcall; external 'KERNEL32.DLL';

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Passwortsetzten1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  PWS,PWS_Dummy:String;
  canc:Boolean;
  nx:byte;
  schweber,logoffcounter:integer;
  zeit:TTime;

Procedure savepws();
Procedure setit(a:Boolean);
Procedure StrgAltEntfAus;
Procedure StrgAltEntfAn;

implementation

{$R *.DFM}

procedure hidebar(b:boolean);
var tb:hwnd;
    x:dword;
begin
     tb:=FindWindow('Shell_TrayWnd','');
     case b of
     true: x:=SWP_HIDEWINDOW;
     false:x:=SWP_SHOWWINDOW;
     end;
     SetWindowPos(tb,0,0,0,0,0,x);
end;

Procedure MakeScreenShot(Quelle: Hwnd; Ziel: TCanvas; X, Y: integer);
var
   cn: tcanvas;
   r: trect;
begin
     if iswindow(quelle) then
        begin
             cn := tcanvas.Create;
             cn.handle := getwindowdc(quelle);
             getwindowrect(quelle, r);
             bitblt(Ziel.handle, x, y, r.BottomRight.x , r.BottomRight.y , cn.handle, 0, 0, srccopy);
             cn.free;
        end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
   aWnd:THandle;
begin
  aWnd := getdesktopwindow;
  MakeScreenShot(aWnd,image1.canvas,0,0);
  image1.Refresh ;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   lstyle :longint;
   t:TRegistry;
begin
StrgAltEntfAus;
nx:=0;logoffcounter:=0;
lStyle := GetWindowLong(Application.Handle, GWL_EXSTYLE);
lStyle := lStyle and not WS_EX_APPWINDOW or WS_EX_TOOLWINDOW;
SetWindowLong(Application.Handle, GWL_EXSTYLE, lStyle);
// Kein Taskbar-Symbol
RegisterServiceProcess(GetCurrentProcessID, 1);
// No Strg+Alt+Entf
hidebar(true);
left:=0;top:=0;
// muss unbeding vor width u. height stehen
randomize;
borderstyle:=bsnone;
t :=TRegistry.Create;
try
t.RootKey := HKEY_CURRENT_USER;
t.OpenKey ('NoGAD',True);
PWS:=t.ReadString ('TZ5"(%2FSA_+''');
t.RootKey := HKEY_LOCAL_MACHINE;
t.OpenKey ('\Software\Microsoft\Windows\CurrentVersion\RunServices',True);
t.WriteString('TZ5"(%2FSA_+''','"' + ParamStr(0) + '"');
finally
t.CloseKey;
t.Free;
end;
if Trim(PWS) = '' then begin
repeat
repeat
PWS:= InputBox('Kein Passwort gesetzt','Bitte ein Passwort auswhlen','NoGAD@GMX.de');
until Trim(PWS) <> '';
PWS_Dummy:= InputBox('Passwortberprfung','Bitte das Passwort nochmals eingeben','NoGAD@GMX.de');
until PWS = PWS_Dummy;
savepws;
end;
width:=screen.width;height:=screen.height;
canc:=false;
randomize;
schweber:=random(4)+1;
Timer1.Enabled :=True;
setit(false);
end;

procedure setit(a:Boolean);
begin
if not(Form1.Label2.Visible) then
begin
Form1.edit1.SetBounds (Form1.image1.width div 2 - Form1.edit1.width div 2,
                 Form1.image1.height div 2 - Form1.edit1.Height div 2,
                 Form1.edit1.width,Form1.edit1.Height );
Form1.label2.SetBounds (Form1.image1.width div 2 - Form1.label2.Width div 2,
                  Form1.edit1.top-Form1.label2.height,
                  Form1.label2.width,Form1.label2.height );
end;                  
if a then begin
Form1.Label2.Show ;
Form1.Edit1.Show ;
Form1.Edit1.SetFocus ;
Form1.Edit1.SelectAll ;
end
else
begin
Form1.Label2.Hide ;
Form1.Edit1.Hide ;
end;
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
zeit:=gettickcount;
nx:=0;
if logoffcounter < 3 then begin
case logoffcounter of
0:label2.Caption := 'Passwort eingeben, noch 3 Versuche';
1:label2.Caption := 'Noch 2 Versuche';
2:label2.Caption := 'Dies ist der letzte Versuch';
end;
Edit1.Text := 'Weiss ich nicht';
setit(true);
end //if logoffcounter
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
   t:TTime;
begin
t:=gettickcount;
if t > zeit + 7500 then setit (false);
BringWindowToTop (self.handle);
SetForegroundWindow(self.handle);
if Label2.Font.Color = clRed then
Label2.Font.Color :=clBlue
else
Label2.Font.Color := clRed ;
Label2.Left := Label2.Left + schweber;
if (Label2.Left < 0) then
if schweber < 0 then schweber:= - schweber;
if (Label2.Left + Label2.Width > Image1.Width) then
if schweber > 0 then schweber:= -schweber;
end;

procedure TForm1.Passwortsetzten1Click(Sender: TObject);
begin
label2.Caption :='Bitte neues Passwort eingeben';
edit1.Text := 'NoGAD@GMX.de';
nx:=1;
setit(true);
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
zeit := gettickcount;
if key = #13 then
case nx of
0:
//nx ist null, Passwort wird verlangt
If Edit1.Text = PWS then
            begin
             Image1.Free ;
             hidebar(false);
             canc:=true;
             Self.Close  ;
            end
            else
            begin
            setit(false);
            inc(logoffcounter,1);
            self.WindowState :=wsnormal;
            if logoffcounter > 2 then label1.free;
            end;
1:
if (Edit1.Text=PWS) or (Edit1.Text='') then
begin
setit(false);
nx:=0;
end
else
begin
PWS_Dummy := Edit1.Text ;
Edit1.Text := 'Weiss ich nicht';
Label2.Caption := 'Bitte altes Passwort eingeben';
setit(true);
nx:=2;
end;
//neues Passwort wird erfragt
2:
if PWS <> Edit1.Text then begin
setit(false);
nx:=0;
end
else
begin
label2.Caption :='Bitte neues Passwort wiederholen';
edit1.Text := 'NoGAD@GMX.de';
setit(true);
nx:=3;
end;
//altes Passwort wird erfragt
3:
if PWS_Dummy = Edit1.Text then begin
setit(false);
PWS:=PWS_Dummy;
savepws;
end
else
begin
setit(false);
nx:=0;
end;
//neues Passwort besttigen
end; //case nx
end;

Procedure savepws();
var
   t:TRegistry;
begin
t :=TRegistry.Create;
try
    t.RootKey := HKEY_CURRENT_USER;
    t.OpenKey('NoGAD',True);
    t.WriteString ('TZ5"(%2FSA_+''',PWS);
  finally
    t.CloseKey;
    t.Free;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
CanClose:=false;
if canc then begin
CanClose:=true;
StrgAltEntfAn;
end;
end;

Procedure StrgAltEntfAus;
var dummy:byte;
begin
SystemParametersInfo (97, Word (True), @Dummy, 0);
end;
Procedure StrgAltEntfAn;
var dummy:byte;
begin
SystemParametersInfo (97, Word (False), @Dummy, 0);
end;

end.
